!---------------------------------------------------------------------------------------
! FLEXINVERT : regriderrors
!---------------------------------------------------------------------------------------
!  Copyright 2013, Rona Thompson
!
!  FLEXINVERT is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  FLEXINVERT is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with FLEXINVERT.  If not, see <http://www.gnu.org/licenses/>.
!---------------------------------------------------------------------------------------
!> Regrids errors to the flexpart resolution
!---------------------------------------------------------------------------------------

subroutine regriderrors(datapost,dataout)

  use mod_var

  implicit none

  integer :: n,nt,ix,jy
  real, dimension(nbox*nemsteps) :: datapost
  real, dimension(numxnest,numynest,nemsteps) :: dataout
 
  dataout(:,:,:)=0.

  do n=1,nemsteps
    do jy=1,numynest
      do ix=1,numxnest
        dataout(ix,jy,n)=datapost((n-1)*nbox+nbox_xy(ix,jy))
      end do
    end do
  end do

end subroutine regriderrors

